/*
 * Lawson Whitney <whitnl73@juno.com>   Use, distribute, or   
 * Fri Mar 24 20:17:26 UTC 2000            change at your own risk. 
 * 
 * noop@nwonknu.org was here 
 * youngs@xemacs.org was here too
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>

#define VERSION "2.0.9.1"
#define errcheck verbose


extern int errno;
char            *tf_name;


static int
fail(message, savetemp)
    char *message;
    int  savetemp;
{
    perror(message);
    if (!savetemp &&
	unlink(tf_name)!=0 &&
	errno != ENOENT){
	perror("couldn't remove tempfile");
	return 2;
    }
    return 1;
} 

static int
copy_all(from, to, andstderr)
    FILE *from;
    FILE *to;
    int andstderr;
{
    char red[4096];
    ssize_t el=0;

    while ((el = fread(red, 1, 4096, from))) {
	fwrite(red, 1, el, to);
	if (ferror(to)) {
	    return -1;
	}
	if (andstderr)
	    fwrite(red, 1, el, stderr);
    }
    return (ferror(from) | ferror(to));
}

static void
its_ok()
{
    fprintf(stderr,"Something went bad, but your data is safe\n");
    fprintf(stderr,"look in %s\n",tf_name);
}

static void
usage(progname)
     char           *progname;
{
    fprintf(stderr, "usage: %s [OPTIONS] filename\n", progname);
    fprintf(stderr, "\t-n --notsafe:\t- write output even if no input\n");
    fprintf(stderr, "\t-V --verbose:\t- copy output to stderr.\n");
    fprintf(stderr, "\t-f --force:\t- disregard permissions of target file.\n");
    fprintf(stderr, "\t-h --help:\t- this message\n");
    fprintf(stderr, "\t-v --version:\t- show version info\n");
}

static void
version()
{
    fprintf(stderr, "safe version %s\n", VERSION);
    fprintf(stderr, "\tCopyright \(C) 2000 Lawson Whitney & Greg Olszewski\n");
    fprintf(stderr, "\tReleased under the terms of the GPL\n");
}

static void
cmderr(Oops)
    char *Oops;
{
    fprintf(stderr, "Oops!  Something wrong with the syntax.\n");
    fprintf(stderr, "\tWhat do you mean, %s ??\n\n", Oops);
}



int
main(argc, argv)
     int             argc;
     char           *argv[]; 
{
    FILE           *fie=0;
    FILE           *ty=0;
    int verbose = 0,
        not_there,
        force = 0,
        mowed,
	supersafe = 1,
	tf_fd,
	parse = 1,
	k,
	option;
    char           fg=0;
    char           red=0;
    char	  *fido = NULL;
    struct       stat enisland;
    uid_t reel;
    uid_t euid;   
    reel=getuid();
/*    fprintf(stderr,"%i\n0",reel);*/
    euid=geteuid();
#ifdef SETUID
#ifdef _POSIX_SAVED_IDS
    seteuid(reel);  /*This causes the access check to be done as*/
#else
    setreuid(euid, reel);    
#endif
#endif
    if (argc<2){
	usage(*argv);
	exit(0);
    }
    if (!strncmp(argv[1],"--version",9)){
	version();
	exit(0);
    }
    if (!strncmp(argv[1],"--help",6)){
	usage(*argv);
	exit(0);
    }
    for (option = 1; option < argc; option++) {
      if (parse) {
	if (!strcmp(argv[option], "--")) {
	    parse = 0;
	    continue;} 
	if ((!strncmp(argv[option],"--", 2))){
	  if  ((!strncmp(argv[option], "--notsafe", 9))) {
	    supersafe=0;
	    continue;}
	  if  ((!strncmp(argv[option], "--verbose", 9))) {
	    verbose=1; 
	    continue;}	   
	  if  ((!strncmp(argv[option], "--force", 7))) {
	    force=1;   
	    continue;}	   
	  if  ((!strncmp(argv[option], "--version", 9))) {
	    version();
	    exit(0);}
	  if  ((!strncmp(argv[option], "--help", 6))) {
	    usage(*argv);
	    exit(0);}
	  goto parserr;
	}
	if ((!strncmp(argv[option], "-", 1))){
	  for (k = 1; k < strlen(argv[option]); k++) {
	    if ((!strncmp(argv[option] + k, "n", 1))) {
	      supersafe = 0;
	      continue;}
	    if ((!strncmp(argv[option] + k, "V", 1))) {
              verbose=1; 
	      continue;}	   
	    if ((!strncmp(argv[option] + k, "f", 1))) {	    
	      force = 1;
	      continue;}
	    if ((!strncmp(argv[option] + k, "v", 1))) {
	      version();
	      exit(0);}
	    if ((!strncmp(argv[option] + k, "h", 1))) {
	      usage(*argv);
	      exit(0);}
	    goto parserr;
	  }
	  continue;
	}
      }
      if (fido) {cmderr(fido);
        goto parserr;}
      fido = argv[option];
      continue;
parserr:	    
	    cmderr(argv[option]);
	    usage(*argv);
	    exit(4);
	
    }
    if (!fido){
	usage(*argv);
	exit(4);}
    tf_name = malloc(strlen(fido) + 12 + strlen(P_tmpdir));
    strcpy(tf_name, fido);
    strcat(tf_name, "XXXXXX");
    tf_fd = mkstemp(tf_name);
    if (tf_fd == -1) {
        strcpy(tf_name, P_tmpdir);
        strcat(tf_name, "/safeXXXXXX");
	tf_fd = mkstemp(tf_name);
        if(tf_fd == -1) {
            perror("mkstemp");
            exit(6);
        }
    }
    mowed = umask(0);/*Ahh... silliness*/
    umask(mowed);
    mowed = 0666&~mowed;
    not_there = stat(fido, &enisland);
    if (!not_there) {
        mowed = enisland.st_mode&(S_ISUID|S_ISGID|S_ISVTX|
				  S_IRWXU|S_IRWXG|S_IRWXO);
	/*If we don't do this, we get a bunch of funky perms because
	 *of other info in st_mode*/
	/* fprintf(stderr,"%oi=mode for file\n",mowed); */
	if (!(force)) {


	    if (access(fido, W_OK)) {/*the invoking uid*/
	        return(fail("can't write outfile",1));
	    }

	}
    }
    if (fchmod(tf_fd, mowed)) perror("fchmod");

    ty=fdopen(tf_fd,"w+");
        
    if (!ty) 
	return(fail("couldn't open tempfile",0));

    if (copy_all(stdin,ty,verbose)){/*stderr here*/
	fclose(ty);
	return(fail("writing failed, your file untouched",0));
    }
    /*fail in a safe way ^*/
    
    rewind(ty);
    if ((red=fgetc(ty)) == EOF) {
	if (ferror(ty))  /*if we error, we're still ok*/
	    return(fail("no data",0));/*we havent touched the outfile*/
	if (supersafe) {
	    fprintf(stderr, "%s: %s: default action won't create empty file\n\t\tuse -n or --notsafe if you really want an empty file\n",
		    argv[0], fido);
	    if (unlink(tf_name)){
		perror("couldn't remove tempfile");
		return 2;
	    }
	    return 0;
	}
    }
#ifndef SETUID
    if ((not_there) \
        || ((euid == enisland.st_uid) && (getegid() == enisland.st_gid)))
#endif /* SETUID */
  {
    if (unlink(fido)==-1 && errno != ENOENT){
	/* we can't get rid of the file we want to write to*/
	
	if (!(errno==EPERM ||
	      errno==EACCES))
	    /* If the error is one of these, we can't remove*/
	    /* the file, but we can truncate it. So don't give*/
	    /* up yet*/
	    
	    return(fail("couldn't deal with outfile",0));/*else lose*/
    }
    /*Here's where trouble starts? -- the file we need to write to*/
     /* is gone... and we are supposed to protect it. */
    else if (link(tf_name,fido)==-1){
	if (!(errno == EXDEV || /* Cross device hardlink*/
	      errno == EPERM || /* File system doesn't support hardlinks */
	      errno == EEXIST)){ /* File is already there???? This one is bad*/
	    /* but can be dealt with */
	    perror("couldn't make outfile");
	    its_ok();/* cover our butt */
	    return 5;
	}
	fg=1; /*file is gone*/
    }else{
	/*success*/
	/* fprintf(stderr,"WE get there\n"); */
	fclose(ty);
	if (unlink(tf_name)){
	    perror("couldn't remove tempfile");
	    return 1;
	}
#ifdef SETUID
        if(!(not_there)) {
#ifdef _POSIX_SAVED_IDS
	  seteuid(euid);
#else
	  setreuid(reel, euid);
#endif              	  	  
	  if (chown(fido,enisland.st_uid,enisland.st_gid)!=0){
	    perror("Couldn't fix outfile ownership");
	    return 1;
	  }
	
	  if (chmod(fido,mowed)){
	    perror("Couldn't fix outfile permissions");
	    return 1;
	  }
	}
#endif      /* SETUID */
	return 0;/* we win! */
    }
  }    
    fie = fopen(fido, "w");
    if (!fie) {
	if (fg){
	    perror("couldn't open outfile");
	    its_ok();/*and its not there... let them know what's happening*/
	    return 5;
	}
	return(fail("couldn't open outfile",0));
    }
	    
    rewind(ty);
    if (copy_all(ty,fie,0)){
	/* Here we're really in trouble... we've written some stuff*/
	/* to the outfile, but failed.. so whatever is there is garbage*/
	/* and we let them know */
	perror("failed writing file");
	its_ok();
	return 5;
    }
    fclose(fie);
    fclose(ty);
    return 0;/*we win!*/
}
